diff --git a/comptime.sh b/comptime.sh
index d5ef7271a4622749786c2d54dc534f5329501ac8..ce771f631781c153dd87e60a20fdad8064d347e9 100755
--- a/comptime.sh
+++ b/comptime.sh
@@ -1,54 +1,44 @@
-#!/bin/bash -e
+#!/bin/sh
 path="."
 if [ x"$1" != x ]; then
 	path="$1"
 fi
 
-versiongit() {
-	gitbranch=`git rev-parse --abbrev-ref HEAD`
-	gitversion=`git rev-parse HEAD`
-	cat <<EOF > $path/comptime.h
+version() {
+	cat <<EOF > "$path/comptime.h"
 
 // Do not edit!  This file was autogenerated
 // by the $0 script with git
 //
-const char* compbranch = "$gitbranch";
-const char* comprevision = "${gitversion:0:8}";
+const char* compbranch = "$1";
+const char* comprevision = "$2";
 EOF
-exit 0
 }
 
-versionsvn() {
-	svnrevision=`svnversion -n $1`
-	cat <<EOF > $path/comptime.h
+versiongit() {
+	gitbranch="$(git rev-parse --abbrev-ref HEAD)"
+	gitversion="$(git rev-parse HEAD | cut -c -8)"
+	version "$gitbranch" "$gitversion";
+	exit 0
+}
 
-// Do not edit!  This file was autogenerated
-// by the $0 script with subversion
-//
-const char* compbranch = "Subversion";
-const char* comprevision = "r$svnrevision";
-EOF
-exit 0
+versionsvn() {
+	svnrevision="$(svnversion -n "$1")"
+	version "Subversion" "r$svnrevision";
+	exit 0
 }
 
 versionfake() {
-	cat <<EOF > $path/comptime.h
-
-// Do not edit!  This file was autogenerated
-// by the $0 script with an unknown or nonexist SCM
-//
-const char* compbranch = "Unknown";
-const char* comprevision = "illegal";
-EOF
+	version "Unknown" "illegal";
 }
 
 compversion() {
-touch $path/comptime.c
-versionfake
-test -d $path/.svn && versionsvn
-test -d $path/../.git && versiongit
-exit 1
+	touch "$path/comptime.c"
+	versionfake
+	[ -d "$path/.svn" ] && versionsvn "$@"
+	[ -d "$path/../.git" ] && versiongit
+	exit 1
 }
 
-test -f $path/comptime.c && compversion
+[ -f "$path/comptime.c" ] && compversion "$@"
 exit 2
diff --git a/src/Makefile b/src/Makefile
index 9cab3e487afb64a913e2eed791cd3fd3754422aa..7571c808933d254613c401fdfc5d75522b750933 100644
--- a/src/Makefile
+++ b/src/Makefile
@@ -357,9 +357,9 @@ $(dbg).txt : $(dbg)
 # this really updates comptime.h
 comptime.c ::
 ifdef WINDOWSHELL
-	$(.)..\comptime.bat .
+	-$(.)..\comptime.bat .
 else
-	$(.)../comptime.sh .
+	-$(.)../comptime.sh .
 endif
 
 # I wish I could make dependencies out of rc files :(